<?php

namespace Modules\Pp\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Pp\Entities\CustomerOrder;
use Modules\Pp\Entities\OrderAttachment;
use Illuminate\Support\Facades\DB;

class AttachmentController extends Controller
{
    public function allOrder()
    {

        try {
            $order = CustomerOrder::all();
            $collection = [];
            for ($i = 0; $i < count($order); $i++) {
                //$value = $employee[$i]->name_withinitial . '#' . $employee[$i]->employee_id;
                array_push($collection, ["id" => $order[$i]->order_id, "value" => $order[$i]->order_id]);
            }
            $responseBody = $this->responseBody(true, "Order", "all", $collection);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function getOrderFromId($id)
    {

        try {
            $order = CustomerOrder::find($id);
            $responseBody = $this->responseBody(true, "Order", "all", $order);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }




    function upload(Request $request)
    {

        try {
            $id = $request->get('order_id');
            $file = $request->file('file');
            $file_name = $file->getClientOriginalName();
            $filename = uniqid() . '_' . time() . '.' . $file_name;
            $file->move(public_path('order'), $filename);

            $order_attachment = new OrderAttachment();
            $order_attachment->order_id = $id;
            $order_attachment->file_path = $filename;
            $order_attachment->save();
        } catch (\Exception $exception) {
            //$responseBody = $this->responseBody(false, "error", "upload", $exception);
        }
        return true;
        //return response()->json(["data" => $responseBody]);
    }


    function allOrderFiles()
    {
        try {
            $all_attachment = OrderAttachment::where('order_id', '=', 0)->get();
            $responseBody = $this->responseBody(true, "Attachment", "all", $all_attachment);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Attachment", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    function allFiles($id)
    {
        try {
            $all_attachment = OrderAttachment::where('order_id', '=', $id)->get();
            $responseBody = $this->responseBody(true, "Attachment", "all", $all_attachment);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Attachment", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    /**
     * updateID
     * This function is used to update order id.
     * @param request This is the paramter to update function
     * @return Json This returns as response.
     */
    public function updateAttachmentID(Request $request)
    {
  
        try {
        
            $orderAttachmentID = DB::select("UPDATE pp_order_attachments 
            SET order_id = (
                          SELECT order_id
                          FROM pp_customer_orders
                          ORDER BY order_id DESC
                          LIMIT 1
                        ) 
            WHERE order_id = 0;
            ");
           
                $responseBody = $this->responseBody(true, "Order", "updated", [$orderAttachmentID]);
        
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    function delete($id)
    {
        try {
            $attachment = OrderAttachment::find($id);
            $delete = $attachment->delete();

            if ($delete) {
                $responseBody = $this->responseBody(true, "Attachment", "deleted", null);
            }
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Attachment", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }




    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
