<?php

namespace Modules\Pp\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\DB;
use Modules\Pp\Entities\CustomerOrder;

class CustomerOrderListController extends Controller
{
      public function allCustomerOrder($year, $month, $order_status, $production_status)
    {
        try {


            $query = 'SELECT pp_customer_orders.*,st_countries.country_name AS country FROM pp_customer_orders INNER JOIN st_customers ON pp_customer_orders.customer_id = st_customers.customer_id INNER JOIN st_countries ON st_customers.country_id = st_countries.country_id  WHERE';
            
	    if ($year == 0 && $month == 0) {
            } else if ($year != 0 && $month == 0) {
                $date = $year . "%";
                $query .= ' pp_customer_orders.date LIKE "' . $date . '" ';
            } else if ($year == 0 && $month != 0) {
                if (strlen($month) == 1) {
                    $date = "0" . $month . "%";
                } else {
                    $date =  $month . "%";
                }
                $query .= ' MONTH(pp_customer_orders.date) = "' . $date . '" ';
            } else {
                if (strlen($month) == 1) {
                    $date = $year . "-0" . $month . "%";
                } else {
                    $date = $year . "-" . $month . "%";
                }
                $query .= ' pp_customer_orders.date LIKE "' . $date . '" ';
            }


            if ($order_status != -1) {
                preg_match('/[^ ]*$/', $query, $results);
                $last_word = $results[0];
                if ($last_word == "WHERE") {
                    $query .= ' pp_customer_orders.order_status= "' . $order_status . '" ';
                } else {
                    $query .= ' AND pp_customer_orders.order_status= "' . $order_status . '" ';
                }
            }

            if ($production_status != -1) {
                preg_match('/[^ ]*$/', $query, $results);
                $last_word = $results[0];
                if ($last_word == "WHERE") {
                    $query .= ' pp_customer_orders.production_status= "' . $production_status . '" ';
                } else {
                    $query .= ' AND pp_customer_orders.production_status= "' . $production_status . '" ';
                }
            }

            if ($order_status == -1 && $production_status == -1 && $year == 0 && $month == 0) {
                $query = 'SELECT *FROM pp_customer_orders ';
            }
            $query .= ' GROUP BY pp_customer_orders.order_id DESC';
            $customer_orders = DB::select($query);
            $responseBody = $this->responseBody(true, "CustomerOrderListController", "allCustomerOrder", $customer_orders);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "CustomerOrderListController", "allCustomerOrder", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }

    public function delete($id)
    {

        try {
            $order = CustomerOrder::where('order_id', $id);
            if ($order) {
                if ($order->delete()) {
                    $query = 'DELETE FROM pp_customer_orders_data WHERE order_id = "' . $id . '"';
                    DB::select($query);
                }
            }

            $responseBody = $this->responseBody(true, "deleteOrder", "deleted", true);
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, "deleteOrder", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function isAllowcateOrder($id)
    {

        $order = CustomerOrder::where([['order_id', '=', $id], ['production_status', '>', 0]])->first();
        if ($order) {
            return 1;
        }
        return 0;
    }



    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
